param m := read "entrada_caballos.in" as "1n" use 1; # Filas
param n := read "entrada_caballos.in" as "1n" skip 1 use 1; # Columnas
param M := (m*n+1); # Cota de total de casillas

set filas := {1..m};
set columnas := {1..n};
set direcciones := {1..4};
set movimiento_caballo := {<df,dc> in {-2..2}*{-2..2} with abs(df*dc) == 2};

param p[filas*columnas] := read "entrada_caballos.in" as "<1n,2n> 3n" skip 2 default 0;

set KN[<i,j> in filas*columnas] := union <df,dc> in movimiento_caballo with (1 <= i+df and i+df <= m) and (1 <= j+dc and j+dc <= n) : {<i+df,j+dc>};

var x[filas*columnas] binary; # Caballo en (i,j)
var y[filas*columnas] binary; # Torre en (i,j)
var z[filas*columnas*direcciones] binary; # 1 <=> torre en (i,j) amenaza caballo en direccion d (d = 1


maximize ganancia : 
	(sum <i,j> in filas*columnas : M*x[i,j]) - sum <i,j> in filas*columnas : y[i,j];

subto amenaza_caballos_1 :
	forall <i,j> in filas*columnas :
		sum <s,t> in KN[i,j] : (x[s,t] + y[s,t] + p[s,t]) <= 2*x[i,j] + M*(1-x[i,j]);
		
subto amenaza_caballos_2 :
	forall <i,j> in filas*columnas :
		sum <s,t> in KN[i,j] : (x[s,t] + y[s,t] + p[s,t]) >= 2*x[i,j];
		
subto amenaza_torres_1_1 : 
	forall <i,j> in filas*columnas :
		forall <q> in {(i+1)..m} with i < m  :
			M*M*z[i,j,1] >= 	sum <s> in {(i+1)..q} : (x[s,j]   - M*y[s,j] - M*p[s,j]); 

subto amenaza_torres_1_2 : 
	forall <i,j> in filas*columnas :
		forall <q> in {(i+1)..m} with i < m  :
			M*z[i,j,1] 	 <= M + sum <s> in {(i+1)..q} : (M*x[s,j] - y[s,j]   - p[s,j]);	
	
subto amenaza_torres_1_3 :
	forall <j> in columnas :
		z[m,j,1] == 0;
		
subto amenaza_torres_2_1 : 
	forall <i,j> in filas*columnas :
		forall <q> in {1..j-1} with j > 1:
			M*M*z[i,j,2] >= sum <t> in {q..j-1} : (x[i,t] - M*y[i,t] - M*p[i,t]);
			
subto amenaza_torres_2_2 : 
	forall <i,j> in filas*columnas :
		forall <q> in {1..j-1} with j > 1:
			M*z[i,j,2] 	 <= M + sum <t> in {q..j-1} : (M*x[i,t] - y[i,t]   - p[i,t]);	

subto amenaza_torres_2_3 :
	forall <i> in filas :
		z[i,1,2] == 0;

subto amenaza_torres_3_1 : 
	forall <i,j> in filas*columnas :
		forall <q> in {1..i-1} with i > 1  :
			M*M*z[i,j,3] >= sum <s> in {q..i-1} : (x[s,j] - M*y[s,j] - M*p[s,j]);
	
subto amenaza_torres_3_2 : 
	forall <i,j> in filas*columnas :
		forall <q> in {1..i-1} with i > 1  :
			M*z[i,j,3] 	 <= M + sum <s> in {q..i-1} : (M*x[s,j] - y[s,j]   - p[s,j]);	
		
subto amenaza_torres_3_3 :
	forall <j> in columnas :
		z[1,j,3] == 0;

subto amenaza_torres_4_1 : 
	forall <i,j> in filas*columnas :
		forall <q> in {(j+1)..n} with j < n :
			M*M*z[i,j,4] >= sum <t> in {(j+1)..q} : (x[i,t] - M*y[i,t] - M*p[i,t]);

subto amenaza_torres_4_2 : 
	forall <i,j> in filas*columnas :
		forall <q> in {(j+1)..n} with j < n :
			M*z[i,j,4] 	 <= M + sum <t> in {(j+1)..q} : (M*x[i,t] - y[i,t]   - p[i,t]);
		
subto amenaza_torres_4_3 :
	forall <i> in filas :
		z[i,n,4] == 0;

subto amenaza_torres :
	forall <i,j> in filas*columnas :
		sum <d> in direcciones : z[i,j,d] >= 1;
				
subto una_por_casilla :
	forall <i,j> in filas*columnas :
		x[i,j] + y[i,j] + p[i,j] <= 1;
	
# subto cota_columnas:
#	forall <j> in columnas :
#		sum <i> in filas : x[i,j] >= floor(m/3);

# subto cota_filas:
#	forall <i> in filas :
#		sum <j> in columnas : x[i,j] >= floor(n/3);		


