class Pieza(): # Esto es asi en Python 3, en Python 2.7 las clases son una subclase de "object" (O sea: poner "class Pieza(object)")
	def __init__(self,tipo,fila,columna,letra):
		self.tipo = tipo
		self.fila = fila
		self.columna = columna
		self.letra = letra
	
	def __str__(self):
		return self.tipo + ": (" + str(self.fila) + ", " + str(self.columna) + ")"

def leer_salida(nombre_archivo,saltear):
	salida = open(nombre_archivo,"r")
	salida_por_linea = [linea.split() for linea in salida][saltear:]

	lista_piezas = []
	mapeo = {'x':'Caballo', 'y':'Torre'}
	for indices,valor,objetivo in salida_por_linea:
		l = indices.split('#') 
		if l[0] != 'z':
			tipo_pieza,fila_pieza,columna_pieza = l
			lista_piezas.append(Pieza(mapeo[tipo_pieza],int(fila_pieza)-1,int(columna_pieza)-1,mapeo[tipo_pieza][0])) # Indexamos desde cero
	return lista_piezas

def leer_entrada(nombre_archivo):
	entrada = open(nombre_archivo,"r")
	entrada_por_linea = [list(map(int,row.split())) for row in entrada]
	m = entrada_por_linea[0][0] # Linea 0 tiene un entero
	n = entrada_por_linea[1][0] # Linea 1 tiene un entero
	lista_piezas = []
	for fila,columna,valor in entrada_por_linea[2:]: # Linea 2 en adelante tienen 3 enteros por linea
		lista_piezas.append(Pieza("Peon",int(fila)-1,int(columna)-1,"P")) # Indexamos desde cero
	return m,n,lista_piezas
	
def imprimir_salida(m,n,piezas_solucion):
	tablero = [['.' for y in range(n)] for x in range(m)] # Tablero vacio

	for pieza in piezas_solucion:
		tablero[pieza.fila][pieza.columna] = pieza.letra

	for fila_tablero in tablero:
		print ("".join(fila_tablero))

############################
# LEEMOS LA SALIDA DE SCIP #
############################

piezas_solucion = leer_salida("solucion_caballos.out",2)

##################################
# LEEMOS LA ENTRADA DEL PROBLEMA #
##################################

m,n,lista_peones = leer_entrada("entrada_caballos.in")
piezas_solucion += lista_peones # Agregamos los peones de la entrada a la solucion

###########################################
# IMPRIMIMOS LA SALIDA EN FORMATO TABLERO #
###########################################

imprimir_salida(m,n,piezas_solucion)


